> ## Documentation Index
> Fetch the complete documentation index at: https://docs.roark.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# Create HTTP request definition

> Creates a new HTTP request definition. The signing secret is only returned in this response and cannot be retrieved later.



## OpenAPI

````yaml /api-reference/openapi.documented.json post /v1/http-request-definition
openapi: 3.1.0
info:
  title: Roark Analytics API
  description: >-
    The Roark Analytics API gives you access to the same API that powers the
    award winning Roark Analytics platform.
  version: 1.0.0
servers:
  - description: Production
    url: https://api.roark.ai
security:
  - Bearer: []
tags:
  - name: Agent
  - name: Agent Endpoint
  - name: Call
  - name: Chat
  - name: Metric
  - name: Metric Policy
  - name: Metric Collection Job
  - name: Simulation Persona
  - name: Simulation Scenario
  - name: Simulation Run Plan
  - name: Simulation Run Plan Job
  - name: Simulation Job
  - name: HTTP Request Definition
  - name: Webhook
  - name: Issue
  - name: Knowledge Base
  - name: Call Analysis
  - name: Health
paths:
  /v1/http-request-definition:
    post:
      tags:
        - HTTP Request Definition
      summary: Create HTTP request definition
      description: >-
        Creates a new HTTP request definition. The signing secret is only
        returned in this response and cannot be retrieved later.
      operationId: postV1Http-request-definition
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/CreateHttpRequestDefinitionInput'
      responses:
        '201':
          description: The created HTTP request definition with signing secret
          content:
            application/json:
              schema:
                type: object
                properties:
                  data:
                    $ref: '#/components/schemas/HttpRequestDefinitionCreateResponse'
                required:
                  - data
        '401':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
                description: Authentication error
              example:
                type: authentication
                code: unauthorized
                message: Authentication required
          description: Unauthorized
        '500':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
                description: Server error
              example:
                type: internal
                code: internal_error
                message: Internal server error
          description: Internal Server Error
      x-codeSamples:
        - lang: JavaScript
          source: >-
            import Roark from '@roarkanalytics/sdk';


            const client = new Roark({
              bearerToken: process.env['ROARK_API_BEARER_TOKEN'], // This is the default and can be omitted
            });


            const httpRequestDefinition = await
            client.httpRequestDefinition.create({
              scope: 'AGENT_OUTBOUND_DIAL',
              url: 'https://example.com',
            });


            console.log(httpRequestDefinition.data);
        - lang: Python
          source: |-
            import os
            from roark_analytics import Roark

            client = Roark(
                bearer_token=os.environ.get("ROARK_API_BEARER_TOKEN"),  # This is the default and can be omitted
            )
            http_request_definition = client.http_request_definition.create(
                scope="AGENT_OUTBOUND_DIAL",
                url="https://example.com",
            )
            print(http_request_definition.data)
components:
  schemas:
    CreateHttpRequestDefinitionInput:
      type: object
      properties:
        scope:
          type: string
          enum:
            - AGENT_OUTBOUND_DIAL
          description: 'Scope: AGENT_OUTBOUND_DIAL'
        url:
          type: string
          format: uri
          description: URL for the HTTP request
        description:
          type:
            - string
            - 'null'
          description: Description of the HTTP request definition
        method:
          type: string
          enum:
            - POST
            - PUT
            - PATCH
            - GET
          default: POST
          description: 'HTTP method (default: POST)'
        body:
          anyOf:
            - type: string
            - type: object
              additionalProperties:
                path: /v1/integrations/livekit-sdk/chunk-upload-url
            - type: 'null'
          description: >-
            Request body template. Accepts a JSON object or a string with
            placeholders like {{phoneNumberToDial}}. Objects are serialized to
            JSON for storage.
        headers:
          type: object
          additionalProperties:
            type: string
          description: Request headers as key-value pairs
      required:
        - scope
        - url
      description: Input for creating an HTTP request definition
    HttpRequestDefinitionCreateResponse:
      allOf:
        - $ref: '#/components/schemas/HttpRequestDefinitionResponse'
      properties:
        signingSecret:
          type: string
          description: Signing secret (only returned on creation)
      required:
        - signingSecret
      description: HTTP request definition with signing secret (returned on creation)
    ErrorResponse:
      type: object
      properties:
        type:
          type: string
          enum:
            - validation
            - authentication
            - forbidden
            - not_found
            - conflict
            - rate_limit
            - internal
          description: The error type category
          examples:
            - validation
            - authentication
        code:
          type: string
          description: Machine-readable error code identifier
          examples:
            - invalid_parameter
            - missing_required_field
            - unauthorized
        message:
          type: string
          description: Human-readable error message
          examples:
            - The request was invalid
            - Authentication required
        param:
          type: string
          description: The parameter that caused the error (if applicable)
          examples:
            - email
            - user_id
        details:
          description: Additional error context information
      required:
        - type
        - code
        - message
    HttpRequestDefinitionResponse:
      type: object
      properties:
        id:
          type: string
          format: uuid
          description: HTTP request definition ID
        scope:
          type: string
          enum:
            - AGENT_OUTBOUND_DIAL
          description: Scope of the HTTP request definition
        description:
          type:
            - string
            - 'null'
          description: Description of the HTTP request definition
        url:
          type: string
          description: URL for the HTTP request
        method:
          type: string
          enum:
            - POST
            - PUT
            - PATCH
            - GET
          description: 'HTTP method: POST, PUT, PATCH, or GET'
        body:
          type:
            - string
            - 'null'
          description: Request body as a string
        parsedBody:
          anyOf:
            - type: object
              additionalProperties:
                path: /v1/integrations/livekit-sdk/chunk-upload-url
            - type: string
            - type: 'null'
          description: Parsed body as a JSON object if valid JSON, otherwise the raw string
        headers:
          type: object
          additionalProperties:
            type: string
          description: Request headers as key-value pairs
        createdAt:
          type: string
          description: Creation timestamp
        updatedAt:
          type: string
          description: Last update timestamp
      required:
        - id
        - scope
        - description
        - url
        - method
        - body
        - parsedBody
        - headers
        - createdAt
        - updatedAt
      description: HTTP request definition
  securitySchemes:
    Bearer:
      type: http
      scheme: bearer
      bearerFormat: JWT

````